<template>
  <v-app>
    <v-container>
      <v-col cols="12" md="8" offset-md="2">
        <v-card elevation="2">
          <v-form ref="form" v-model="valid">
            <v-card-title>
              COVID-19 | ATTESTATION DE DÉPLACEMENT DÉROGATOIRE
            </v-card-title>
            <v-card-subtitle
              >Basé sur le code source du service officiel consultable sur
              <a
                href="https://github.com/LAB-MI/attestation-deplacement-derogatoire-q4-2020"
                >GitHub</a
              >.
            </v-card-subtitle>
            <v-card-text>
              <v-row class="d-flex" ref="chips">
                <v-col
                  class="justify-center"
                  v-for="profile in profiles"
                  :key="profile.id"
                >
                  <v-chip
                    color="primary"
                    :outlined="profile.id === profileId"
                    close
                    @click:close="remove(profile.id)"
                    @click="load(profile.id)"
                  >
                    <v-icon left>
                      mdi-account-circle-outline
                    </v-icon>
                    {{ profile.firstname }} {{ profile.lastname }}
                  </v-chip>
                </v-col>
                <v-col>
                  <v-chip color="primary" :outlined="!profileId" @click="reset">
                    <v-icon left>
                      mdi-account-plus
                    </v-icon>
                    Nouveau profile
                  </v-chip>
                </v-col>
              </v-row>
              <v-row>
                <v-col>
                  <v-row v-if="!profileId">
                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="firstname"
                        :rules="nameRules"
                        label="Prénom"
                        required
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="lastname"
                        :rules="nameRules"
                        label="Nom"
                        required
                      ></v-text-field>
                    </v-col>
                  </v-row>
                  <v-row v-if="!profileId">
                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="birthday"
                        label="Date de naissance"
                        prepend-icon="mdi-calendar"
                        required
                        v-mask="'##/##/####'"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="birthplace"
                        label="Lieu de naissance"
                        required
                      ></v-text-field>
                    </v-col>
                  </v-row>
                  <v-row v-if="!profileId">
                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="address"
                        label="Adresse"
                        required
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" md="2">
                      <v-text-field
                        v-model="zipcode"
                        label="Code Postal"
                        required
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" md="4">
                      <v-text-field
                        v-model="city"
                        label="Ville"
                        required
                      ></v-text-field>
                    </v-col>
                  </v-row>
                  <v-row>
                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="exitDate"
                        label="Date de sortie"
                        prepend-icon="mdi-calendar"
                        required
                        v-mask="'##/##/####'"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field
                        v-model="exitTime"
                        label="Heure de sortie"
                        prepend-icon="mdi-clock-time-four-outline"
                        v-mask="'##:##'"
                        required
                      ></v-text-field>
                    </v-col>
                  </v-row>
                  <v-row v-if="!profileId">
                    <v-col class="d-flex flex-row-reverse" cols="12">
                      <v-btn icon class="primary white--text" @click="save">
                        <v-icon>mdi-content-save</v-icon>
                      </v-btn>
                    </v-col>
                  </v-row>
                  <v-row class="justify-center">
                    <v-btn-toggle
                      dense
                      tile
                      multiple
                      v-model="choices"
                      :style="
                        $vuetify.breakpoint.xs ? 'flex-direction:column' : ''
                      "
                    >
                      <v-tooltip
                        bottom
                        v-for="reason in reasons"
                        :key="reason.code"
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn v-bind="attrs" v-on="on">
                            <v-icon
                              :left="$vuetify.breakpoint.xs"
                              :small="$vuetify.breakpoint.xs"
                              >{{ reason.icon }}</v-icon
                            >
                            {{
                              $vuetify.breakpoint.xs ? reason.shortLabel : ""
                            }}
                          </v-btn>
                        </template>
                        <span>{{ reason.label }}</span>
                      </v-tooltip>
                    </v-btn-toggle>
                  </v-row>
                </v-col>
              </v-row>
            </v-card-text>
            <v-card-actions>
              <v-btn
                block
                large
                class="primary white--text"
                @click="generate"
                :disabled="!valid"
              >
                <v-icon>mdi-file-pdf-outline</v-icon> Générer mon attestation
              </v-btn>
            </v-card-actions>
          </v-form>
          <v-snackbar v-model="notification" :timeout="timeout">
            L'attestation est téléchargée sur votre appareil.
            <template v-slot:action="{ attrs }">
              <v-btn color="blue" text v-bind="attrs" @click="snackbar = false">
                Close
              </v-btn>
            </template>
          </v-snackbar>
        </v-card>
      </v-col>
    </v-container>
  </v-app>
</template>

<script>
import { pdf } from "./mixins/pdf.js";
import moment from "moment";

export default {
  name: "App",
  mixins: [pdf],
  data: () => ({
    profiles: {},
    profileId: "",

    valid: true,
    firstname: "",
    lastname: "",
    birthday: "",
    birthplace: "",
    address: "",
    city: "",
    zipcode: "",
    choices: [],
    exitDate: "",
    exitTime: "",

    reasons: [
      {
        code: "travail",
        icon: "mdi-office-building-outline",
        status: false,
        shortLabel: " Travail",
        label:
          "Déplacements entre le domicile et le lieu d’exercice de l’activité professionnelle ou un établissement d’enseignement ou de formation ; déplacements professionnels ne pouvant être différés ; déplacements pour un concours ou un examen ;",
      },
      {
        code: "achats_culturel_cultuel",
        icon: "mdi-food-fork-drink",
        status: false,
        shortLabel: " Achats/Culture/Culte",
        label:
          "Déplacements pour se rendre dans un établissement culturel autorisé ou un lieu de culte ; déplacements pour effectuer des achats de biens, pour des services dont la fourniture est autorisée, pour les retraits de commandes et les livraisons à domicile ;",
      },
      {
        code: "sante",
        icon: "mdi-medical-bag",
        status: false,
        shortLabel: " Santé",
        label:
          "Consultations, examens et soins ne pouvant être assurés à distance et l’achat de médicaments ;",
      },
      {
        code: "famille",
        icon: "mdi-hand-heart-outline",
        status: false,
        shortLabel: " Famille",
        label:
          "Déplacements pour motif familial impérieux, pour l'assistance aux personnes vulnérables et précaires ou la garde d'enfants ;",
      },

      {
        code: "handicap",
        icon: "mdi-wheelchair-accessibility",
        status: false,
        shortLabel: "Handicap",
        label:
          "Déplacements des personnes en situation de handicap et leur accompagnant ;",
      },
      {
        code: "sport_animaux",
        icon: "mdi-run-fast",
        status: false,
        shortLabel: "Promenade",
        label:
          "Déplacements en plein air ou vers un lieu de plein air, sans changement du lieu de résidence, dans la limite de trois heures quotidiennes et dans un rayon maximal de vingt kilomètres autour du domicile, liés soit à l’activité physique ou aux loisirs individuels, à l’exclusion de toute pratique sportive collective et de toute proximité avec d’autres personnes, soit à la promenade avec les seules personnes regroupées dans un même domicile, soit aux besoins des animaux de compagnie ;",
      },
      {
        code: "convocation",
        icon: "mdi-scale-balance",
        status: false,
        shortLabel: "Convocation",
        label:
          "Convocations judiciaires ou administratives et déplacements pour se rendre dans un service public ;",
      },
      {
        code: "missions",
        icon: "mdi-handshake",
        status: false,
        shortLabel: "Missions",
        label:
          "Participation à des missions d'intérêt général sur demande de l'autorité administrative ;",
      },
      {
        code: "enfants",
        icon: "mdi-human-male-child",
        status: false,
        shortLabel: "Ecole",
        label:
          "Déplacements pour chercher les enfants à l’école et à l’occasion de leurs activités périscolaires.",
      },
    ],

    nameRules: [
      (v) => !!v || "Name is required",
      (v) => v.length <= 10 || "Name must be less than 10 characters",
    ],
    email: "",
    emailRules: [
      (v) => !!v || "E-mail is required",
      (v) => /.+@.+/.test(v) || "E-mail must be valid",
    ],

    notification: false,
    timeout: 5000,
  }),
  created() {
    const today = new Date();
    this.exitDate = moment(today).format("DDMMYYYY");
    this.exitTime = moment(today).format("HHmm");

    if (localStorage.profiles) {
      this.profiles = JSON.parse(localStorage.profiles);
      if (this.profiles) {
        let profileId = Object.keys(this.profiles)[0];
        let profile = this.profiles[profileId];
        this.profileId = profile.id;
        this.firstname = profile.firstname;
        this.lastname = profile.lastname;
        this.birthday = profile.birthday;
        this.birthplace = profile.birthplace;
        this.address = profile.address;
        this.city = profile.city;
        this.zipcode = profile.zipcode;
      }
    }
  },
  mounted() {
    this.validate();
  },
  methods: {
    validate: function() {
      this.$refs.form.validate();
    },
    reset: function() {
      this.profileId = null;
      this.firstname = "";
      this.lastname = "";
      this.birthday = "";
      this.birthplace = "";
      this.address = "";
      this.city = "";
      this.zipcode = "";
    },
    load: function(profileId) {
      let profile = this.profiles[profileId];
      this.profileId = profile.id;
      this.firstname = profile.firstname;
      this.lastname = profile.lastname;
      this.birthday = profile.birthday;
      this.birthplace = profile.birthplace;
      this.address = profile.address;
      this.city = profile.city;
      this.zipcode = profile.zipcode;
    },
    save: function() {
      let profile = {
        id: this.firstname + ":" + this.lastname,
        firstname: this.firstname,
        lastname: this.lastname,
        birthday: this.birthday,
        birthplace: this.birthplace,
        address: this.address,
        city: this.city,
        zipcode: this.zipcode,
      };
      this.profiles[profile.id] = profile;
      this.profileId = profile.id;
      localStorage.profiles = JSON.stringify(this.profiles);
      this.$forceUpdate();
    },
    remove: function(profileId) {
      delete this.profiles[profileId];
      localStorage.profiles = JSON.stringify(this.profiles);
      this.$forceUpdate();
      this.reset();
    },
    generate: function() {
      let codeChoices = "";
      this.choices.forEach(
        function(index) {
          codeChoices += this.reasons[index].code + ", ";
        }.bind(this)
      );
      this.genPdf(
        this.profiles[this.profileId],
        this.exitDate,
        this.exitTime,
        codeChoices.substring(0, codeChoices.length - 2)
      ).then((pdfBlob) => {
        const link = document.createElement("a");
        const url = window.URL.createObjectURL(pdfBlob);
        link.href = url;
        link.download = `attestation-${this.exitDate}_${this.exitTime}.pdf`;
        document.body.appendChild(link);
        link.click();
        this.notification = true;
      });
    },
  },
};
</script>
